// Copyright (c) 2016, root.ext@gmail.com. All rights reserved. Use of this source code
// is governed by a BSD-style license that can be found in the LICENSE file.

import '../lib/dna.dart';

const int VK_SUCCESS = 0;

int VK_STRUCTURE_TYPE_APPLICATION_INFO = 0;
int VK_STRUCTURE_TYPE_INSTANCE_CREATE_INFO = 1;

@Library('libvulkan.so.1')
class Vulkan {
  dynamic lib = new DynamicLibrary<Vulkan>();

  int vkCreateInstance(
    @Param(C_STRUCT) VkInstanceCreateInfo createInfo,
    @Param(C_POINTER) VkAllocationCallbacks allocator,
    @Param(C_POINTER) @Out() Ref<int> instance)
  { return lib.vkCreateInstance(createInfo, allocator, instance); }

}

@Struct()
class VkApplicationInfo {
  @Field(C_INT) int sType;
  @Field(C_POINTER) int pNext;
  @Field(C_POINTER) String pApplicationName;
  @Field(C_UINT) int applicationVersion;
  @Field(C_POINTER) String pEngineName;
  @Field(C_UINT) int engineVersion;
  @Field(C_UINT) int apiVersion;
}

@Struct()
class VkInstanceCreateInfo {
  @Field(C_INT)  int sType;
  @Field(C_POINTER) int pNext;
  @Field(C_UINT) int flags;
  @Field(C_STRUCT) VkApplicationInfo pApplicationInfo;
  @Field(C_UINT) int enabledLayerCount;
  @Field(C_POINTER) List<String> ppEnabledLayerNames;
  @Field(C_UINT) int enabledExtensionCount;
  @Field(C_POINTER) List<String> ppEnabledExtensionNames;
}


class VkAllocationCallbacks {}
class VkInstance {}