// Copyright (c) 2016, root.ext@gmail.com. All rights reserved. Use of this source code
// is governed by a BSD-style license that can be found in the LICENSE file.

@TestOn("linux")

import '../lib/dna.dart';
import 'package:test/test.dart';
import 'dart:io';


void main() {

  group('base tests', () {
    int library;

    setUp(() {
      library = loadLibrary('libc.so.6');
    });

    tearDown(() {
      freeLibrary(library);
    });

    test('library', () {
      expect(library, isNonZero);
    });

    test('empty vm', () {
      var vm = createCallVM(256);
      expect(vm, isNonZero);
      freeCallVM(vm);
    });

    test('getpid', () {
      var method = findSymbol(library, 'getpid');
      expect(method, isNonZero);
      var vm = createCallVM(256);
      var processId = callFunction(vm, method, new String.fromCharCodes([C_INT]));
      freeCallVM(vm);

      expect(processId, isNonZero);
      expect(processId, equals(pid));
    });


  });
}
