// Copyright (c) 2016, root.ext@gmail.com. All rights reserved. Use of this source code
// is governed by a BSD-style license that can be found in the LICENSE file.

@TestOn("windows")

import 'dart:io';
import 'package:test/test.dart';
import '../lib/dna.dart';


void main() {

  group('base tests', () {
    int library;

    setUp(() {
      library =  loadLibrary('kernel32.dll');
    });

    tearDown(() {
      freeLibrary(library);
    });

    test('library', () {
      expect(library, isNonZero);
    });

    test('empty vm', () {
      var vm = createCallVM(256);
      expect(vm, isNonZero);
      freeCallVM(vm);
    });

    test('getpid', () {

      var method = findSymbol(library, 'GetCurrentProcess');
      expect(method, isNonZero);
      var vm = createCallVM(256);
      var processPointer = callFunction(vm, method, new String.fromCharCodes([C_INT]));
      freeCallVM(vm);

      method = findSymbol(library, 'GetProcessId');
      expect(method, isNonZero);
      vm = createCallVM(256);
      pushParameters(vm, new String.fromCharCodes([C_INT]), [processPointer]);
      var processId = callFunction(vm, method, new String.fromCharCodes([C_INT]));
      freeCallVM(vm);

      expect(processId, isNonZero);
      expect(processId, equals(pid));
    });


  });
}
